extern "C" {
#include "metroid.h"
#define LIMITE 3  //nombre de sprites sans collision
char map[100][100] = {0};
#include "votrePersonnage.h"
#include "boss.h"


const unsigned char* tileset[]=
{
    nospr,
    pilier1,
    nospr,
    //limite
    sol1, //+0
    sol2,
    sol3,
    mur1
};

const color_t* tileset_palette[]=
{
    nospr_palette,
    pilier1_palette,
    nospr_palette,
    //limite
    sol1_palette, //+0
    sol2_palette, //+1
    sol3_palette, //+2
    mur1_palette //+3
};

void Ajouter_sol(int x,int y, int longueur)
{
    int i;
    for (i=x;i<x+longueur;i++)
    {
        map[y][i] = i%3+LIMITE;
    }
}

void Ajouter_mur1(int x,int y, int hauteur)
{
    int i;
    for (i=y;i<y+hauteur;i++)
    {
        map[i][x] = LIMITE+3;
    }
}
void Ajouter_pilier1(int x,int y, int hauteur)
{
    int i;
    for (i=y;i<y+hauteur;i++)
    {
        map[i][x] = 1;
    }
}
void Ajouter_finish(int x,int y, int hauteur)
{
    int i;
    for (i=y;i<y+hauteur;i++)
    {
        map[i][x] = 2;
    }
}

void InitMap(int lvl,__PERSO * Tperso,__COORD * scrollBg)
{
    int perso = Tperso->choixDuPerso;
    int i,j;
    for (i=0;i<100;i++)
    {
        for (j=0;j<100;j++)
        {
            map[j][i]=0;
        }
    }
    if (lvl == 1)
    {
        Ajouter_sol(1,0,11);
        Ajouter_sol(1,5,2);
        Ajouter_mur1(0,0,6);
        Ajouter_mur1(11,0,10);
        Ajouter_mur1(3,5,10);
        Ajouter_pilier1(3,15,27);
        Ajouter_sol(8,10,18);
        Ajouter_sol(4,14,8);
        Ajouter_mur1(12,14,7);
        Ajouter_finish(50,3,30);
        Ajouter_sol(12,44,12);
        Ajouter_mur1(12,23,22);
        Ajouter_sol(9,20,4);
        Ajouter_sol(9,23,4);
        Ajouter_mur1(9,20,4);
        Ajouter_mur1(26,10,20);
        Ajouter_mur1(23,41,4);
        Ajouter_sol(24,41,2);
        Ajouter_mur1(26,34,8);
        Ajouter_sol(27,34,6);
        Ajouter_mur1(33,32,3);
        Ajouter_mur1(35,30,3);
        Ajouter_mur1(38,28,3);
        Ajouter_mur1(42,26,3);
        Ajouter_mur1(45,24,3);
        Ajouter_mur1(47,13,12);
        Ajouter_mur1(43,8,13);
        Ajouter_mur1(30,23,8);
        Ajouter_sol(45,24,2);
        Ajouter_sol(24,30,6);
        Ajouter_sol(27,20,17);
        Ajouter_sol(34,32,1);
        Ajouter_sol(35,30,3);
        Ajouter_sol(40,28,2);
        Ajouter_sol(41,26,4);
        Ajouter_sol(44,8,19);
        Ajouter_sol(48,13,15);

        METROID_SPIRATE.pos.x = 64;
        METROID_SPIRATE.pos.y = 64;
        scrollBg->x = 30;
        scrollBg->y = 25;

    }
    if (lvl == 2)
    {
        Ajouter_sol(0,0,20);
        Ajouter_sol(0,19,20);
        Ajouter_mur1(0,0,20);
        Ajouter_mur1(19,0,20);
        METROID_SPIRATE.pos.x = 64;
        METROID_SPIRATE.pos.y = 120;
        scrollBg->x = 15;
        scrollBg->y = 15;

    }
}
void AfficheMap(__PERSO * Tperso,__COORD scroll,__COORD scrollBg)
{
    int posX = Tperso->personnage[Tperso->choixDuPerso].pos.x /32;
    int posY = Tperso->personnage[Tperso->choixDuPerso].pos.y /32;
    int i,j,k;
    for (i=-1;i<3;i++)
    {
        CopySpriteNbitMasked(night_middle,-34+(i*224)+SCROLLX,57+SCROLLY,224,103,night_middle_palette,0xffff,8);
        for (j=0;j<70;j++)
        {
            for (k=0;k<2;k++)
            {
                if(57-j*2+SCROLLY>=-1 && -34+(i*224)+k*112+SCROLLX<384 && -34+(i*224)+k*112+SCROLLX>-224) CopySpriteNbitMasked(night_top,-34+(i*224)+k*112+SCROLLX,57-j*2+SCROLLY,112,2,night_top_palette,0xffff,1);
                if (158+j*2+SCROLLY<=217 && -34+(i*224)+k*112+SCROLLX<384 && -34+(i*224)+k*112+SCROLLX>-224)CopySpriteNbitMasked(night_bottom,-34+(i*224)+k*112+SCROLLX,158+j*2+SCROLLY,112,2,night_bottom_palette,0xffff,1);
            }
        }
    }

    for (i= posX-7;i< posX+7;i++)
    {
        for (j=posY-4;j<posY+4;j++)
        {
            if (j>=0 && i>=0)
                if (map[j][i]!=0 )CopySpriteNbitMasked(tileset[map[j][i]],i*32+scroll.x,j*32+scroll.y,32,32,tileset_palette[map[j][i]],0xf800,8);
        }
    }
}

void AfficheVie(__VIE structure)
{
    int i,j;
    for (j=23;j<23+(structure.vie*101)/500;j++)
    {
        if (structure.vie >500/10)
            CopySpriteNbitMasked(life_good,j,0,1,10,life_good_palette,0xf800,8);
        else
            CopySpriteNbitMasked(life_bad,j,0,1,10,life_bad_palette,0xf800,8);
    }
    for (j=23;j<23+(structure.bouclier*101)/500;j++)
    {
        if (structure.bouclier >500/10)
            CopySpriteNbitMasked(life_good,j,12,1,10,life_good_palette,0xf800,8);
        else
            CopySpriteNbitMasked(life_bad,j,12,1,10,life_bad_palette,0xf800,8);
    }
    for (j=23;j<23+(structure.energie*101)/500;j++)
    {
        if (structure.energie >500/10)
            CopySpriteNbitMasked(life_good,j,24,1,10,life_good_palette,0xf800,8);
        else
            CopySpriteNbitMasked(life_bad,j,24,1,10,life_bad_palette,0xf800,8);
    }


    for (j=0;j<3;j++)
    {
        CopySpriteNbitMasked(life,15,j*12,116,11,life_palette,0xf800,1);
    }
     CopySpriteNbitMasked(vie,0,0,11,11,vie_palette,0xf800,2);
     CopySpriteNbitMasked(bouclier,0,12,11,11,bouclier_palette,0xf800,8);
     CopySpriteNbitMasked(energie,0,24,11,11,energie_palette,0xf800,2);
}

void InitTirsMetroid(__TIRS * tirsMetroid)
{
        int i;
        for (i=0;i<MAX_BULLET;i++)
        {
            tirsMetroid[i].dir.x = 0;
            tirsMetroid[i].dir.y = 0;
            tirsMetroid[i].tirs = false;
            tirsMetroid[i].pos.x = 0;
            tirsMetroid[i].pos.y = 0;
            tirsMetroid[i].type = 0;
            tirsMetroid[i].annim = 0;
        }
}

void AfficheProjectileEtDeplace(__TIRS * tirsMetroid,__COORD scroll,bool boss,__BOSS* Tboss)
{
    int i;
    for (i=0;i<MAX_BULLET;i++)
    {
        if (tirsMetroid[i].tirs == true)
        {
            CopySpriteNbitMasked(balle[tirsMetroid[i].annim],tirsMetroid[i].pos.x-8+scroll.x,tirsMetroid[i].pos.y-8+scroll.y,16,16,balle_palette[tirsMetroid[i].annim],0x8010,8);
            tirsMetroid[i].annim++;
            if (tirsMetroid[i].annim>=8) //annimation des shoots
                tirsMetroid[i].annim = 0;
            tirsMetroid[i].pos.x+= tirsMetroid[i].dir.x;
            tirsMetroid[i].pos.y+= tirsMetroid[i].dir.y;
            if (map[tirsMetroid[i].pos.y/32][tirsMetroid[i].pos.x/32]>=LIMITE)
                tirsMetroid[i].tirs = false;
            if (boss && tirsMetroid[i].pos.x>Tboss->pos.x-50 && tirsMetroid[i].pos.x<Tboss->pos.x+50 && tirsMetroid[i].pos.y<Tboss->pos.y+10 && tirsMetroid[i].pos.y>Tboss->pos.y-100) //si les projectile touche le boss
            {
                Tboss->annimation.prendDegat = 1;
                Tboss->vie-=20;
                tirsMetroid[i].tirs = false;
            }
        }
    }
}


void Game(__PERSO* Tperso)
{

    int lvl = 1;
    int perso = Tperso->choixDuPerso;;
    __TIRS tirsMetroid[50];
    __BOSS Tboss;  //boss du jeu
    __VIE vieBouclierEnergie = {500,0,500,0,500,0};



    __COORD scroll= {0,0}; //= {scrolling en x, scrolling en y);
    __COORD scrollBg ={0,0} ; //= {scrolling en x, scrolling en y);

    bool metroidPeutTirer;

    bool boss;
    do
    {
        InitTboss (&Tboss);
        InitTperso(Tperso);
        InitTirsMetroid(tirsMetroid);
        boss = (lvl == 2) ; //si il y a un boss
        InitMap(lvl,Tperso,&scrollBg);
        metroidPeutTirer = false;
        vieBouclierEnergie.bouclierCompteur = 0;
        vieBouclierEnergie.bouclier = 500;
        vieBouclierEnergie.energie = 500;
        vieBouclierEnergie.enegieCompteur = 0;
        vieBouclierEnergie.vieCompteur = 0;
        vieBouclierEnergie.vie = 500;
        do{}while(!keydown(31));
        do
        {
            scroll.x = 200-Tperso->personnage[Tperso->choixDuPerso].pos.x;//(180,110) = coord du personnage (fixe sur l'cran)
            scroll.y = 130-Tperso->personnage[Tperso->choixDuPerso].pos.y;
            AfficheMap(Tperso,scroll,scrollBg);
            if (boss) Boss(&Tboss,scroll,Tperso,&vieBouclierEnergie,tirsMetroid);
            Vous(Tperso,scroll,&vieBouclierEnergie,tirsMetroid,&metroidPeutTirer);
            AfficheProjectileEtDeplace(tirsMetroid,scroll,boss,&Tboss);
            if(!METROID_SPIRATE.mort.mort)AfficheVie(vieBouclierEnergie);
            if(!METROID_SPIRATE.mort.mort)print_number_cg(10,100,Tboss.vie,0xffff);
            Flip();
        }while (!keydown(47) && Tboss.mort.annimation_fondblanc !=17 && METROID_SPIRATE.mort.annimation !=12 && map[METROID_SPIRATE.pos.y/32][METROID_SPIRATE.pos.x/32]!=2);
        if (METROID_SPIRATE.mort.annimation ==12)
        {
            do{
                print_text_cg(138,50,"G A M E   O V E R",0xffff);
                print_text_cg(96,150,"Appuyer sur EXIT pour continuer",0xffff);
                Flip();
            }while(!keydown(47) && !keydown(48));
        }
        lvl ++;
    }while (!keydown(47) && lvl != 3 && METROID_SPIRATE.mort.annimation !=12);
}

void AfficheScenario()
{
    for (int i = 216-46;i>-80;i-=1+6*(keydown(77)))
    {
        FillRectangle(0,216-46,384,46,0x0000);
        print_text_cg((384-(6*45))/2,i,   "En 2123 l'humanite a decouvert qu'ils ne sont",0xffff); //70  45
        print_text_cg((384-(6*24))/2,i+15,"pas seul dans l'univers.",0xffff);//72 24
        print_text_cg((384-(6*44))/2,i+30,"23 annees plus tard des extraterrestres sous",0xffff); //44
        print_text_cg((384-(6*48))/2,i+45,"la domination d'omega tente d'envahir la planete",0xffff); //48
        print_text_cg((384-(6*46))/2,i+60,"terre, mais seul un homme peut sauver la terre",0xffff);//46
        print_text_cg((384-(6*39))/2,i+75,"contre cette invasion extraterrestre.",0xffff);//39
        print_text_cg((384-(6*59))/2,i+120,"Desormais, l'avenir de la planete terre dependra de lui ...",0xffff);//59
        FillRectangle(0,216-46,384,216,0x0000);
        FillRectangle(0,0,384,46,0x0000);
        for (int j=0;j<32;j++)
        {
            drawLineAlpha(0,216-46-j,384,216-46-j,0x0000,32-j);  //effet transparence
            drawLineAlpha(0,46+j,384,46+j,0x0000,32-j);
        }
        Flip();
    }
}


void G3A_main( void )
{
    Clear();
    __PERSO Tperso;
    AfficheEcranPrincipale();
    if (!keydown(48) && !keydown(47))
    {
        AfficheScenario();
        Tperso.choixDuPerso=0;
        Game(&Tperso);
    }
}

#pragma section _BR_Size
unsigned long BR_Size;
#pragma section

}

